package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.DaoOperation;

import org.seasar.extension.unit.S2TestCase;
import org.seasar.framework.aop.interceptors.MockInterceptor;

public class DaoOperationImplTest extends S2TestCase {
    DaoOperation daoOperation;
    MockInterceptor sampleDaoMock;
    MockInterceptor anotherDaoMock;
    
    public void setUpDaõvtBNXIDDaoĂяos() throws Exception {
        include("DaoOperationTest_case1.dicon");
    }
    public void testDaõvtBNXIDDaoĂяos() throws Exception {
        SampleEntity entity = (SampleEntity) daoOperation.getById("sample", 100);
        assertNotNull(entity);
        assertEquals(100, entity.getId());
        assertEquals("Higa", entity.getName());
        
        assertTrue(sampleDaoMock.isInvoked("getById"));
        Object[] actualArgs = sampleDaoMock.getArgs("getById");
        assertEquals(new Long(100), actualArgs[0]);
    }
    

    public void setUpDaõvtBNXIDDaoĂяosOp()
            throws Exception {
        include("DaoOperationTest_case2.dicon");
    }
    public void testDaõvtBNXIDDaoĂяosOp()
            throws Exception {
        SampleEntity2 entity = (SampleEntity2)
            daoOperation.getById("another", 150);
        assertNotNull(entity);
        assertEquals(150, entity.getId());
        assertEquals("DHH", entity.getNickName());

        assertTrue(anotherDaoMock.isInvoked("getById"));
        Object[] actualArgs =
            anotherDaoMock.getArgs("getById");
        assertEquals(new Long(150), actualArgs[0]);
    }
}
